#include "nuc.h"
#include <string.h>
//#include "crc16.h"

uint8_t nucbuf[32];

static void NUC_IdleCallback(void) {	
	// osThreadFlagsSet(thread_alert,SIGNAL_NUC_RAW_REDY);
	// detect_hook(NUC_TOE);
}

int8_t NUC_Init(NUC_t *nuc){
    if(nuc == NULL) return DEVICE_ERR_NULL;
  //信号量的东西 // if((thread_alert = osThreadGetId()) == NULL ) return DEVICE_ERR_NULL;
   BSP_UART_RegisterCallback(BSP_UART_AI,BSP_UART_IDLE_LINE_CB,
                            NUC_IdleCallback);
	
   return DEVICE_OK;
}

int8_t NUC_StartReceiving(void) {
  if (HAL_UARTEx_ReceiveToIdle_DMA(BSP_UART_GetHandle(BSP_UART_AI),
                           (uint8_t *)nucbuf,
                           sizeof(nucbuf)) == HAL_OK)
    return DEVICE_OK;
  return DEVICE_ERR;
}

int8_t NUC_Restart(void) {
  __HAL_UART_DISABLE(BSP_UART_GetHandle(BSP_UART_AI));
  __HAL_UART_ENABLE(BSP_UART_GetHandle(BSP_UART_AI));
  return DEVICE_OK;
}

bool_t NUC_WaitDmaCplt(void) {
  // return (osThreadFlagsWait(SIGNAL_NUC_RAW_REDY, osFlagsWaitAll,500) ==
  //         SIGNAL_NUC_RAW_REDY);
}

int8_t NUC_RawParse(NUC_t *n){
	if(n ==NULL) return DEVICE_ERR_NULL;
 	union 
	{
		float x[3];
		char data[12];
	}instance;//方便在浮点数和字符数组之间进行数据转换

  if(nucbuf[0]!=HEAD) goto error;  //发送ID不是底盘
  else{
    n->status_fromnuc =nucbuf[1];
		n->ctrl_status =nucbuf[2];
    switch (n->status_fromnuc)
    {
		case VISION:
				/* 协议格式 
		   0xFF  HEAD
		   0x0X  控制帧
		   0x01  相机帧
		   x    fp32
		   y    fp32
		   z    fp32
		   0xFE  TAIL
		  */
		if(nucbuf[15]!=TAIL)goto error;
       instance.data[3] = nucbuf[6];
       instance.data[2] = nucbuf[5];
       instance.data[1] = nucbuf[4];
       instance.data[0] = nucbuf[3];
      n->vision.x= instance.x[0]; //
       instance.data[7] = nucbuf[10];
       instance.data[6] = nucbuf[9];
       instance.data[5] = nucbuf[8];
       instance.data[4] = nucbuf[7];
      n->vision.y = instance.x[1];//
       instance.data[11] = nucbuf[14];
       instance.data[10] = nucbuf[13];
       instance.data[9] = nucbuf[12];
       instance.data[8] = nucbuf[11];
      n->vision.z = instance.x[2];//
      break;
    case PICK:
		   break;
    }
     return DEVICE_OK;
  }
    error:
   
    return DEVICE_ERR;
}


int8_t NUC_HandleOffline(NUC_t *cmd)
{
	if(cmd == NULL) return DEVICE_ERR_NULL;
	 memset(cmd, 0, sizeof(*cmd));
	return 0;
}
